gtkmm: Gtk::HandleBox Class Reference

gtkmm 3.8.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::HandleBox Class Reference
Widgets | Container Widgets

A widget for detachable window portions. More...

Inheritance diagram for Gtk::HandleBox:
[legend]

## Public Member Functions
virtual | ~HandleBox ()
GtkHandleBox* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkHandleBox* | gobj () const
| Provides access to the underlying C GtkObject. More...
| HandleBox ()
void | set_shadow_type (ShadowType type)
| Sets the type of shadow to be drawn around the border of the handle box. More...
ShadowType | get_shadow_type () const
| Gets the type of shadow drawn around the handle box. More...
void | set_handle_position (PositionType position)
| Sets the side of the handlebox where the handle is drawn. More...
PositionType | get_handle_position () const
| Gets the handle position of the handle box. More...
void | set_snap_edge (PositionType edge)
| Sets the snap edge of a handlebox. More...
PositionType | get_snap_edge () const
| Gets the edge used for determining reattachment of the handle box. More...
bool | is_child_detached () const
| Whether the handlebox's child is currently detached. More...
Glib::SignalProxy1< void, Widget* > | signal_child_attached ()
Glib::SignalProxy1< void, Widget* > | signal_child_detached ()
Glib::PropertyProxy< ShadowType > | property_shadow_type ()
| Appearance of the shadow that surrounds the container. More...
Glib::PropertyProxy_ReadOnly < ShadowType > | property_shadow_type () const
| Appearance of the shadow that surrounds the container. More...
Glib::PropertyProxy< PositionType > | property_handle_position ()
| Position of the handle relative to the child widget. More...
Glib::PropertyProxy_ReadOnly < PositionType > | property_handle_position () const
| Position of the handle relative to the child widget. More...
Glib::PropertyProxy< PositionType > | property_snap_edge ()
| Side of the handlebox that's lined up with the docking point to dock the handlebox. More...
Glib::PropertyProxy_ReadOnly < PositionType > | property_snap_edge () const
| Side of the handlebox that's lined up with the docking point to dock the handlebox. More...
Glib::PropertyProxy< bool > | property_snap_edge_set ()
| Whether to use the value from the snap_edge property or a value derived from handle_position. More...
Glib::PropertyProxy_ReadOnly < bool > | property_snap_edge_set () const
| Whether to use the value from the snap_edge property or a value derived from handle_position. More...
Glib::PropertyProxy_ReadOnly < bool > | property_child_detached () const
| A boolean value indicating whether the handlebox's child is attached or detached. More...
Public Member Functions inherited from Gtk::Bin
virtual | ~Bin ()
GtkBin* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkBin* | gobj () const
| Provides access to the underlying C GtkObject. More...
Gtk::Widget* | get_child ()
| Gets the child of the Gtk::Bin, or `0` if the bin contains no child widget. More...
const Gtk::Widget* | get_child () const
| Gets the child of the Gtk::Bin, or `0` if the bin contains no child widget. More...
void | remove ()
| Remove the contained object Since this can only hold one object it is not necessary to specify which object to remove like other containers. More...
void | add_label (const Glib::ustring& label, bool mnemonic=false, double x_align=0.5, double y_align=0.5)
| Add a Label object. More...
void | add_label (const Glib::ustring& label, bool mnemonic, Align x_align, Align y_align=ALIGN_CENTER)
| Add a Label object. More...
void | add_pixlabel (const std::string& pixfile, const Glib::ustring& label, double x_align=0.5, double y_align=0.5)
| Add Image and Label objects. More...
Public Member Functions inherited from Gtk::Container
virtual | ~Container ()
GtkContainer* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkContainer* | gobj () const
| Provides access to the underlying C GtkObject. More...
void | set_border_width (guint border_width)
| Sets the border width of the container. More...
guint | get_border_width () const
| Retrieves the border width of the container. More...
virtual void | add (Widget& widget)
void | remove (Widget& widget)
| Removes widget from container. More...
void | set_resize_mode (ResizeMode resize_mode)
| Sets the resize mode for the container. More...
ResizeMode | get_resize_mode () const
| Returns the resize mode for the container. More...
void | check_resize ()
| Request that contained widgets check their size. More...
void | foreach (const ForeachSlot& slot)
| Operate on contained items. More...
void | forall (const ForeachSlot& slot)
| Operate on contained items, including internal children. More...
std::vector< Widget* > | get_children ()
| (internal) Operate on contained items (see foreach()) More...
std::vector< const Widget* > | get_children () const
| Returns the container's non-internal children. More...
void | propagate_draw (Widget& child, const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| When a container receives a call to the draw function, it must send synthetic Gtk::Widget::signal_draw() calls to all children that don't have their own Gdk::Windows. More...
void | set_focus_chain (const std::vector< Widget* >& focusable_widgets)
| Sets a focus chain, overriding the one computed automatically by GTK+. More...
bool | has_focus_chain () const
std::vector< Widget* > | get_focus_chain ()
std::vector< const Widget* > | get_focus_chain () const
void | unset_focus_chain ()
| Removes a focus chain explicitly set with set_focus_chain(). More...
void | set_reallocate_redraws (bool needs_redraws=true)
| Sets the reallocate_redraws flag of the container to the given value. More...
void | set_focus_child (Widget& widget)
| Sets the focus on a child. More...
Widget* | get_focus_child ()
| Returns the current focus child widget inside container. More...
const Widget* | get_focus_child () const
| Returns the current focus child widget inside container. More...
void | set_focus_vadjustment (const Glib::RefPtr< Adjustment >& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. More...
Glib::RefPtr< Adjustment > | get_focus_vadjustment ()
| Retrieves the vertical focus adjustment for the container. More...
Glib::RefPtr< const Adjustment > | get_focus_vadjustment () const
| Retrieves the vertical focus adjustment for the container. More...
void | set_focus_hadjustment (const Glib::RefPtr< Adjustment >& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. More...
Glib::RefPtr< Adjustment > | get_focus_hadjustment ()
| Retrieves the horizontal focus adjustment for the container. More...
Glib::RefPtr< const Adjustment > | get_focus_hadjustment () const
| Retrieves the horizontal focus adjustment for the container. More...
void | resize_children ()
GType | child_type () const
| Returns the type of the children supported by the container. More...
WidgetPath | get_path_for_child (const Widget& child) const
| Returns a newly created widget path representing all the widget hierarchy from the toplevel down to and including child. More...
Glib::SignalProxy1< void, Widget* > | signal_add ()
Glib::SignalProxy1< void, Widget* > | signal_remove ()
Glib::SignalProxy0< void > | signal_check_resize ()
Glib::SignalProxy1< void, Widget* > | signal_set_focus_child ()
void | show_all_children (bool recursive=true)
Public Member Functions inherited from Gtk::Widget
virtual | ~Widget ()
| Destroys the widget. More...
GtkWidget* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkWidget* | gobj () const
| Provides access to the underlying C GtkObject. More...
void | show ()
| Flags a widget to be displayed. More...
void | show_now ()
| Shows a widget. More...
void | hide ()
| Reverses the effects of show(), causing the widget to be hidden (invisible to the user). More...
void | show_all ()
| Recursively shows a widget, and any child widgets (if the widget is a container). More...
void | queue_draw ()
| Equivalent to calling queue_draw_area() for the entire area of a widget. More...
void | queue_draw_area (int x, int y, int width, int height)
| Convenience function that calls queue_draw_region() on the region created from the given coordinates. More...
void | queue_draw_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Invalidates the rectangular area of widget defined by region by calling gdk_window_invalidate_region() on the widget's window and all its child windows. More...
void | queue_resize ()
| This function is only for use in widget implementations. More...
void | size_allocate (const Allocation& allocation)
| This function is only used by Gtk::Container subclasses, to assign a size and position to their child widgets. More...
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout. More...
void | get_preferred_width (int& minimum_width, int& natural_width) const
| Retrieves a widget's initial minimum and natural width. More...
void | get_preferred_height_for_width (int width, int& minimum_height, int& natural_height) const
| Retrieves a widget's minimum and natural height if it would be given the specified width. More...
void | get_preferred_height (int& minimum_height, int& natural_height) const
| Retrieves a widget's initial minimum and natural height. More...
void | get_preferred_width_for_height (int height, int& minimum_width, int& natural_width) const
| Retrieves a widget's minimum and natural width if it would be given the specified height. More...
void | get_preferred_size (Requisition& minimum_size, Requisition& natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget's preference for height-for-width management. More...
void | add_accelerator (const Glib::ustring& accel_signal, const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods, AccelFlags accel_flags)
| Installs an accelerator for this widget in accel_group that causes accel_signal to be emitted if the accelerator is activated. More...
bool | remove_accelerator (const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods)
| Removes an accelerator from widget, previously installed with add_accelerator(). More...
void | set_accel_path (const Glib::ustring& accel_path, const Glib::RefPtr< AccelGroup >& accel_group)
| Given an accelerator group, accel_group, and an accelerator path, accel_path, sets up an accelerator in accel_group so whenever the key binding that is defined for accel_path is pressed, widget will be activated. More...
bool | mnemonic_activate (bool group_cycling)
| Emits the Gtk::Widget::signal_mnemonic_activate() signal. More...
bool | event (GdkEvent* event)
| Rarely-used function. More...
int | send_expose (GdkEvent*event)
| Very rarely-used function. More...
bool | send_focus_change (GdkEvent*event)
| Sends the focus change event to widget. More...
bool | activate ()
| For widgets that can be "activated" (buttons, menu items, etc.) this function activates them. More...
void | reparent (Widget& new_parent)
| Moves a widget from one Gtk::Container to another, handling reference count issues to avoid destroying the widget. More...
bool | intersect (const Gdk::Rectangle& area) const
bool | intersect (const Gdk::Rectangle& area, Gdk::Rectangle& intersection) const
| Computes the intersection of a widget's area and area, storing the intersection in intersection, and returns `true` if there was an intersection. More...
::Cairo::RefPtr< ::Cairo::Region > | region_intersect (const ::Cairo::RefPtr< ::Cairo::Region >& region) const
| Computes the intersection of a widget's area and region, returning the intersection. More...
void | freeze_child_notify ()
| Stops emission of Gtk::Widget::signal_child_notify() signals on widget. More...
void | child_notify (const Glib::ustring& child_property)
| Emits a Gtk::Widget::signal_child_notify() signal for the child property child_property on widget. More...
void | thaw_child_notify ()
| Reverts the effect of a previous call to freeze_child_notify(). More...
void | set_can_focus (bool can_focus=true)
| Specifies whether widget can own the input focus. More...
bool | get_can_focus () const
| Determines whether widget can own the input focus. More...
bool | has_focus () const
| Determines if the widget has the global input focus. More...
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel. More...
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus. More...
void | grab_focus ()
| Causes widget to have the keyboard focus for the Gtk::Window it's inside. More...
void | set_can_default (bool can_default=true)
| Specifies whether widget can be a default widget. More...
bool | get_can_default () const
| Determines whether widget can be a default widget. More...
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel. More...
void | grab_default ()
| Causes widget to become the default widget. More...
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
bool | get_receives_default () const
| Determines whether widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
bool | has_grab () const
| Determines whether the widget is currently grabbing events, so it is the only widget receiving input events (keyboard and mouse). More...
bool | device_is_shadowed (const Glib::RefPtr< const Gdk::Device >& device)
| Returns `true` if device has been shadowed by a GTK+ device grab on another widget, so it would stop sending events to widget. More...
void | add_modal_grab ()
| Block events to everything else than this widget and its children. More...
void | remove_modal_grab ()
| Remove the modal grab of the widget in case it was previously grabbed. More...
void | set_name (const Glib::ustring& name)
| Widgets can be named, which allows you to refer to them from a CSS file. More...
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget. More...
void | set_state (StateType state)
| This function is for use in widget implementations. More...
StateType | get_state () const
| Returns the widget's state. More...
void | set_state_flags (StateFlags flags, bool clear=true)
| This function is for use in widget implementations. More...
void | unset_state_flags (StateFlags flags)
| This function is for use in widget implementations. More...
StateFlags | get_state_flags () const
| Returns the widget state as a flag set. More...
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget. More...
bool | get_sensitive () const
| Returns the widget's sensitivity (in the sense of returning the value that has been set using set_sensitive()). More...
bool | is_sensitive () const
| Returns the widget's effective sensitivity, which means it is sensitive itself and also its parent widget is sensitive. More...
void | set_visible (bool visible=true)
| Sets the visibility state of widget. More...
bool | get_visible () const
| Determines whether the widget is visible. More...
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible. More...
bool | get_has_window () const
| Determines whether widget has a Gdk::Window of its own. More...
bool | get_is_toplevel () const
| Determines whether widget is a toplevel widget. More...
bool | get_is_drawable () const
| Determines whether widget can be drawn to. More...
bool | get_realized () const
| Determines whether widget is realized. More...
bool | get_mapped () const
| Whether the widget is mapped. More...
void | set_app_paintable (bool app_paintable=true)
| Sets whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler. More...
bool | get_app_paintable () const
| Determines whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler. More...
void | set_double_buffered (bool double_buffered=true)
| Widgets are double buffered by default; you can use this function to turn off the buffering. More...
bool | get_double_buffered () const
| Determines whether the widget is double buffered. More...
void | set_redraw_on_allocate (bool redraw_on_allocate=true)
| Sets whether the entire widget is queued for drawing when its size allocation changes. More...
void | set_child_visible (bool is_visible=true)
| Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show(). More...
bool | get_child_visible () const
| Gets the value set with set_child_visible(). More...
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the widget's window if it is realized, `0` otherwise. More...
Glib::RefPtr< const Gdk::Window > | get_window () const
| Returns the widget's window if it is realized, `0` otherwise. More...
void | register_window (const Glib::RefPtr< Gdk::Window >& window)
| Registers a Gdk::Window with the widget and sets it up so that the widget recieves events for it. More...
void | unregister_window (const Glib::RefPtr< Gdk::Window >& window)
| Unregisters a Gdk::Window from the widget that was previously set up with register_window(). More...
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget. More...
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget. More...
Allocation | get_allocation () const
| Retrieves the widget's location. More...
void | set_allocation (const Allocation& allocation)
| Sets the widget's allocation. More...
Container* | get_parent ()
| Returns the parent container of widget. More...
const Container* | get_parent () const
| Returns the parent container of widget. More...
Glib::RefPtr< Gdk::Window > | get_parent_window ()
| Gets widget's parent window. More...
Glib::RefPtr< const Gdk::Window > | get_parent_window () const
| Gets widget's parent window. More...
void | set_parent_window (const Glib::RefPtr< const Gdk::Window >& parent_window)
| Sets a non default parent window for widget. More...
bool | child_focus (DirectionType direction)
| This function is used by custom widget implementations; if you're writing an app, you'd use grab_focus() to move the focus to a particular widget, and Gtk::Container::set_focus_chain() to change the focus tab order. More...
bool | keynav_failed (DirectionType direction)
| This function should be called whenever keyboard navigation within a single widget hits a boundary. More...
void | error_bell ()
| Notifies the user about an input-related error on this widget. More...
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget; that is, the widget's size request will be at least width by height. More...
void | get_size_request (int& width, int& height) const
| Gets the size request that was explicitly set for the widget using set_size_request(). More...
void | set_events (Gdk::EventMask events)
| Sets the event mask (see Gdk::EventMask) for a widget. More...
void | add_events (Gdk::EventMask events)
| Adds the events in the bitfield events to the event mask for widget. More...
void | set_device_events (const Glib::RefPtr< const Gdk::Device >& device, Gdk::EventMask events)
| Sets the device event mask (see Gdk::EventMask) for a widget. More...
void | add_device_events (const Glib::RefPtr< const Gdk::Device >& device, Gdk::EventMask events)
| Adds the device events in the bitfield events to the event mask for widget. More...
void | set_opacity (double opacity)
| Request the widget to be rendered partially transparent, with opacity 0 being fully transparent and 1 fully opaque. More...
double | get_opacity () const
| Fetches the requested opacity for this widget. More...
void | set_device_enabled (const Glib::RefPtr< Gdk::Device >& device, bool enabled=true)
| Enables or disables a Gdk::Device to interact with widget and all its children. More...
bool | get_device_enabled (const Glib::RefPtr< const Gdk::Device >& device) const
| Returns whether device can interact with widget and its children. More...
Container* | get_toplevel ()
| This function returns the topmost widget in the container hierarchy widget is a part of. More...
const Container* | get_toplevel () const
| This function returns the topmost widget in the container hierarchy widget is a part of. More...
Widget* | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type. More...
const Widget* | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type. More...
Glib::RefPtr< Gdk::Visual > | get_visual ()
| Gets the visual that will be used to render widget. More...
Glib::RefPtr< Gdk::Screen > | get_screen ()
| Get the Gdk::Screen from the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Screen > | get_screen () const
| Get the Gdk::Screen from the toplevel window associated with this widget. More...
bool | has_screen () const
| Checks whether there is a Gdk::Screen is associated with this widget. More...
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< Gdk::Window > | get_root_window ()
| Get the root window where this widget is located. More...
Glib::RefPtr< const Gdk::Window > | get_root_window () const
| Get the root window where this widget is located. More...
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget. More...
Glib::RefPtr< Clipboard > | get_clipboard (const Glib::ustring& selection)
| Returns the clipboard object for the given selection to be used with widget. More...
Glib::RefPtr< const Clipboard > | get_clipboard (const Glib::ustring& selection) const
| Returns the clipboard object for the given selection to be used with widget. More...
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space. More...
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space. More...
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget. More...
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag (see get_hexpand()) will be used. More...
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space. More...
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space. More...
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget. More...
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag (see get_vexpand()) will be used. More...
void | queue_compute_expand ()
| Mark widget as needing to recompute its expand flags. More...
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible. More...
bool | get_support_multidevice () const
| Returns `true` if widget is multiple pointer aware. More...
void | set_support_multidevice (bool support_multidevice=true)
| Enables or disables multiple pointer awareness. More...
Glib::RefPtr< Atk::Object > | get_accessible ()
| Returns the accessible object that describes the widget to an assistive technology. More...
Glib::RefPtr< const Atk::Object > | get_accessible () const
| Returns the accessible object that describes the widget to an assistive technology. More...
Align | get_halign () const
| Gets the value of the Gtk::Widget::property_halign() property. More...
void | set_halign (Align align)
| Sets the horizontal alignment of widget. More...
Align | get_valign () const
| Gets the value of the Gtk::Widget::property_valign() property. More...
void | set_valign (Align align)
| Sets the vertical alignment of widget. More...
int | get_margin_left () const
| Gets the value of the Gtk::Widget::property_margin_left() property. More...
void | set_margin_left (int margin)
| Sets the left margin of widget. More...
int | get_margin_right () const
| Gets the value of the Gtk::Widget::property_margin_right() property. More...
void | set_margin_right (int margin)
| Sets the right margin of widget. More...
int | get_margin_top () const
| Gets the value of the Gtk::Widget::property_margin_top() property. More...
void | set_margin_top (int margin)
| Sets the top margin of widget. More...
int | get_margin_bottom () const
| Gets the value of the Gtk::Widget::property_margin_bottom() property. More...
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget. More...
Gdk::EventMask | get_events () const
| Returns the event mask for the widget (a bitfield containing flags from the Gdk::EventMask enumeration). More...
Gdk::EventMask | get_device_events (const Glib::RefPtr< const Gdk::Device >& device) const
| Returns the events mask for the widget corresponding to an specific device. More...
void | get_pointer (int& x, int& y) const
| Obtains the location of the mouse pointer in widget coordinates. More...
bool | is_ancestor (Widget& ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers. More...
bool | translate_coordinates (Widget& dest_widget, int src_x, int src_y, int& dest_x, int& dest_y)
| Translate coordinates relative to src_widget's allocation to coordinates relative to dest_widget's allocations. More...
void | override_color (const Gdk::RGBA& color, StateFlags state=(StateFlags) 0)
void | unset_color (StateFlags state=(StateFlags) 0)
void | override_background_color (const Gdk::RGBA& color, StateFlags state=(StateFlags) 0)
void | unset_background_color (StateFlags state=(StateFlags) 0)
void | override_font (const Pango::FontDescription& font_desc)
| Sets the font to use for a widget. More...
void | unset_font ()
void | override_symbolic_color (const Glib::ustring& name, const Gdk::RGBA& color)
| Sets a symbolic color for a widget. More...
void | unset_symbolic_color (const Glib::ustring& name)
void | override_cursor (const Gdk::RGBA& cursor, const Gdk::RGBA& secondary_cursor)
| Sets the cursor color to use in a widget, overriding the Gtk::Widget::property_cursor_color() and Gtk::Widget::property_secondary_cursor_color() style properties. More...
void | unset_cursor ()
void | reset_style ()
| Updates the style context of widget and all descendents by updating its widget path. More...
template<class PropertyType >
void | get_style_property (const Glib::ustring& the_property_name, PropertyType& value) const
| Gets the value of a style property of widget. More...
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context with the appropriate font map, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget. More...
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring& text)
| Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Gdk::Pixbuf > | render_icon_pixbuf (const StockID& stock_id, IconSize size)
| A convenience function that uses the theme engine and style settings for widget to look up stock_id and render it to a pixbuf. More...
void | set_composite_name (const Glib::ustring& name)
| Sets a widgets composite name. More...
void | unset_composite_name ()
Glib::ustring | get_composite_name () const
| Obtains the composite name of a widget. More...
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget. More...
TextDirection | get_direction () const
| Gets the reading direction for a particular widget. More...
void | shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Sets a shape for this widget's GDK window. More...
void | input_shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Sets an input shape for this widget's GDK window. More...
WidgetPath | get_path () const
| Returns the Gtk::WidgetPath representing widget, if the widget is not connected to a toplevel widget, a partial path will be created. More...
std::vector< Widget* > | list_mnemonic_labels ()
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
std::vector< const Widget* > | list_mnemonic_labels () const
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
void | add_mnemonic_label (Widget& label)
| Adds a widget to the list of mnemonic labels for this widget. More...
void | remove_mnemonic_label (Widget& label)
| Removes a widget from the list of mnemonic labels for this widget. More...
void | drag_get_data (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::ustring& target, guint32 time)
| Gets the data associated with a drag. More...
void | drag_highlight ()
| Draws a highlight around a widget. More...
void | drag_unhighlight ()
| Removes a highlight set by gtk_drag_highlight() from a widget. More...
void | drag_dest_set (DestDefaults flags=DestDefaults(0), Gdk::DragAction actions=Gdk::DragAction(0))
void | drag_dest_set (const std::vector< TargetEntry >& targets, DestDefaults flags=DEST_DEFAULT_ALL, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_dest_set_proxy (const Glib::RefPtr< Gdk::Window >& proxy_window, Gdk::DragProtocol protocol, bool use_coordinates)
| Sets this widget as a proxy for drops to another window. More...
void | drag_dest_unset ()
| Clears information about a drop destination set with gtk_drag_dest_set(). More...
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::RefPtr< TargetList >& target_list) const
| Looks for a match between context->targets and the dest_target_list, returning the first matching target, otherwise returning Gdk::NONE. More...
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context) const
Glib::RefPtr< TargetList > | drag_dest_get_target_list ()
| Returns the list of targets this widget can accept from drag-and-drop. More...
Glib::RefPtr< const TargetList > | drag_dest_get_target_list () const
| Returns the list of targets this widget can accept from drag-and-drop. More...
void | drag_dest_set_target_list (const Glib::RefPtr< TargetList >& target_list)
| Sets the target types that this widget can accept from drag-and-drop. More...
void | drag_dest_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag destination. More...
void | drag_dest_add_image_targets ()
| Add the image targets supported by Gtk::Selection to the target list of the drag destination. More...
void | drag_dest_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag destination. More...
void | drag_source_set (const std::vector< TargetEntry >& targets, Gdk::ModifierType start_button_mask=Gdk::MODIFIER_MASK, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_source_unset ()
| Undoes the effects of set(). More...
void | drag_source_set_icon (const Glib::RefPtr< Gdk::Pixbuf >& pixbuf)
| Sets the icon that will be used for drags from a particular widget from a Gdk::Pixbuf. More...
void | drag_source_set_icon (const StockID& stock_id)
| Sets the icon that will be used for drags from a particular source to a stock icon. More...
void | drag_source_set_icon (const Glib::ustring& icon_name)
| Sets the icon that will be used for drags from a particular source to a themed icon. More...
void | drag_source_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag source. More...
void | drag_source_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag source. More...
void | drag_source_add_image_targets ()
| Add the writable image targets supported by Gtk::Selection to the target list of the drag source. More...
Glib::RefPtr< Gdk::DragContext > | drag_begin (const Glib::RefPtr< TargetList >& targets, Gdk::DragAction actions, int button, GdkEvent*event)
| Initiates a drag on the source side. More...
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a mouse drag starting at ( start_x, start_y) and ending at ( current_x, current_y) has passed the GTK+ drag threshold, and thus should trigger the beginning of a drag-and-drop operation. More...
void | drag_set_as_icon (const Glib::RefPtr< Gdk::DragContext >& context, int hot_x, int hot_y)
void | queue_resize_no_redraw ()
| This function works like queue_resize(), except that the widget is not invalidated. More...
bool | get_no_show_all () const
| Returns the current value of the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget. More...
void | set_no_show_all (bool no_show_all=true)
| Sets the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget. More...
void | set_parent (Widget& parent)
| This function is useful only when implementing subclasses of Gtk::Container. More...
void | unparent ()
| This function is only for use in widget implementations. More...
void | map ()
| This function is only for use in widget implementations. More...
void | unmap ()
| This function is only for use in widget implementations. More...
void | draw_insertion_cursor (const ::Cairo::RefPtr< ::Cairo::Context >& cr, const Gdk::Rectangle& location, bool is_primary, TextDirection direction, bool draw_arrow=true)
| Draws a text caret on cr at location. More...
void | set_tooltip_window (Window& custom_window)
| Replaces the default, usually yellow, window used for displaying tooltips with custom_window. More...
Window* | get_tooltip_window ()
| Returns the Gtk::Window of the current tooltip. More...
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located. More...
void | set_tooltip_text (const Glib::ustring& text)
| Sets text as the contents of the tooltip. More...
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget. More...
void | set_tooltip_markup (const Glib::ustring& markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language. More...
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget. More...
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on widget to has_tooltip. More...
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property. More...
int | get_width () const
int | get_height () const
bool | is_composited () const
| Whether widget can rely on having its alpha channel drawn correctly. More...
bool | in_destruction () const
| Returns whether the widget is currently being destroyed. More...
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget. More...
Glib::RefPtr< Gtk::StyleContext > | get_style_context () const
| Returns the style context associated to widget. More...
Gdk::ModifierType | get_modifier_mask (Gdk::ModifierIntent intent)
| Returns the modifier mask the widget's windowing system backend uses for a particular purpose. More...
Glib::SignalProxy0< void > | signal_show ()
Glib::SignalProxy0< void > | signal_hide ()
Glib::SignalProxy0< void > | signal_map ()
| Emitted on mapping of a widget to the screen. More...
Glib::SignalProxy0< void > | signal_unmap ()
Glib::SignalProxy0< void > | signal_realize ()
| Emitted on realization of a widget. More...
Glib::SignalProxy0< void > | signal_unrealize ()
Glib::SignalProxy1< void, Allocation& > | signal_size_allocate ()
Glib::SignalProxy1< void, Gtk::StateType > | signal_state_changed ()
Glib::SignalProxy1< void, Gtk::StateFlags > | signal_state_flags_changed ()
Glib::SignalProxy1< void, Widget* > | signal_parent_changed ()
| Informs objects that their parent changed. More...
Glib::SignalProxy1< void, Widget* > | signal_hierarchy_changed ()
Glib::SignalProxy0< void > | signal_style_updated ()
Glib::SignalProxy1< void, TextDirection > | signal_direction_changed ()
Glib::SignalProxy1< void, bool > | signal_grab_notify ()
Glib::SignalProxy1< void, GParamSpec* > | signal_child_notify ()
Glib::SignalProxy1< bool, bool > | signal_mnemonic_activate ()
Glib::SignalProxy0< void > | signal_grab_focus ()
Glib::SignalProxy1< bool, DirectionType > | signal_focus ()
Glib::SignalProxy1< bool, GdkEvent* > | signal_event ()
Glib::SignalProxy1< void, GdkEvent* > | signal_event_after ()
Glib::SignalProxy1< bool, GdkEventButton* > | signal_button_press_event ()
| Event triggered by user pressing button. More...
Glib::SignalProxy1< bool, GdkEventButton* > | signal_button_release_event ()
| Event triggered by user releasing button. More...
Glib::SignalProxy1< bool, GdkEventScroll* > | signal_scroll_event ()
Glib::SignalProxy1< bool, GdkEventMotion* > | signal_motion_notify_event ()
| Event triggered by user moving pointer. More...
Glib::SignalProxy1< bool, GdkEventAny* > | signal_delete_event ()
Glib::SignalProxy1< bool, const ::Cairo::RefPtr < ::Cairo::Context >& > | signal_draw ()
Glib::SignalProxy1< bool, GdkEventKey* > | signal_key_press_event ()
| Event triggered by a key press will widget has focus. More...
Glib::SignalProxy1< bool, GdkEventKey* > | signal_key_release_event ()
| Event triggered by a key release will widget has focus. More...
Glib::SignalProxy1< bool, GdkEventCrossing* > | signal_enter_notify_event ()
| Event triggered by pointer entering widget area. More...
Glib::SignalProxy1< bool, GdkEventCrossing* > | signal_leave_notify_event ()
| Event triggered by pointer leaving widget area. More...
Glib::SignalProxy1< bool, GdkEventConfigure* > | signal_configure_event ()
| Event triggered by a window resizing. More...
Glib::SignalProxy1< bool, GdkEventFocus* > | signal_focus_in_event ()
Glib::SignalProxy1< bool, GdkEventFocus* > | signal_focus_out_event ()
Glib::SignalProxy1< bool, GdkEventAny* > | signal_map_event ()
Glib::SignalProxy1< bool, GdkEventAny* > | signal_unmap_event ()
Glib::SignalProxy1< bool, GdkEventProperty* > | signal_property_notify_event ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_clear_event ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_request_event ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_notify_event ()
Glib::SignalProxy1< bool, GdkEventProximity* > | signal_proximity_in_event ()
Glib::SignalProxy1< bool, GdkEventProximity* > | signal_proximity_out_event ()
Glib::SignalProxy1< bool, GdkEventVisibility* > | signal_visibility_notify_event ()
Glib::SignalProxy1< bool, GdkEventWindowState* > | signal_window_state_event ()
Glib::SignalProxy3< void, SelectionData&, guint, guint > | signal_selection_get ()
Glib::SignalProxy2< void, const SelectionData&, guint > | signal_selection_received ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::DragContext >& > | signal_drag_begin ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::DragContext >& > | signal_drag_end ()
Glib::SignalProxy4< void, const Glib::RefPtr < Gdk::DragContext > &, SelectionData&, guint, guint > | signal_drag_data_get ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::DragContext >& > | signal_drag_data_delete ()
Glib::SignalProxy2< bool, const Glib::RefPtr < Gdk::DragContext > &, DragResult > | signal_drag_failed ()
Glib::SignalProxy2< void, const Glib::RefPtr < Gdk::DragContext >&, guint > | signal_drag_leave ()
Glib::SignalProxy4< bool, const Glib::RefPtr < Gdk::DragContext >&, int, int, guint > | signal_drag_motion ()
Glib::SignalProxy4< bool, const Glib::RefPtr < Gdk::DragContext >&, int, int, guint > | signal_drag_drop ()
Glib::SignalProxy6< void, const Glib::RefPtr < Gdk::DragContext >&, int, int, const SelectionData &, guint, guint > | signal_drag_data_received ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::Screen >& > | signal_screen_changed ()
Glib::SignalProxy0< void > | signal_composited_changed ()
Glib::SignalProxy0< bool > | signal_popup_menu ()
Glib::SignalProxy4< bool, int, int, bool, const Glib::RefPtr < Tooltip >& > | signal_query_tooltip ()
Glib::SignalProxy1< bool, GdkEventGrabBroken* > | signal_grab_broken_event ()
Glib::SignalProxy1< bool, GdkEventExpose* > | signal_damage_event ()
Glib::SignalProxy1< bool, GdkEventTouch* > | signal_touch_event ()
Glib::PropertyProxy < Glib::ustring > | property_name ()
| The name of the widget. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_name () const
| The name of the widget. More...
Glib::PropertyProxy< Container* > | property_parent ()
| The parent widget of this widget. More...
Glib::PropertyProxy_ReadOnly < Container* > | property_parent () const
| The parent widget of this widget. More...
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible. More...
Glib::PropertyProxy_ReadOnly < bool > | property_visible () const
| Whether the widget is visible. More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input. More...
Glib::PropertyProxy_ReadOnly < bool > | property_sensitive () const
| Whether the widget responds to input. More...
Glib::PropertyProxy< bool > | property_app_paintable ()
| Whether the application will paint directly on the widget. More...
Glib::PropertyProxy_ReadOnly < bool > | property_app_paintable () const
| Whether the application will paint directly on the widget. More...
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget can accept the input focus. More...
Glib::PropertyProxy_ReadOnly < bool > | property_can_focus () const
| Whether the widget can accept the input focus. More...
Glib::PropertyProxy< bool > | property_has_focus ()
| Whether the widget has the input focus. More...
Glib::PropertyProxy_ReadOnly < bool > | property_has_focus () const
| Whether the widget has the input focus. More...
Glib::PropertyProxy< bool > | property_is_focus ()
| Whether the widget is the focus widget within the toplevel. More...
Glib::PropertyProxy_ReadOnly < bool > | property_is_focus () const
| Whether the widget is the focus widget within the toplevel. More...
Glib::PropertyProxy< bool > | property_can_default ()
| Whether the widget can be the default widget. More...
Glib::PropertyProxy_ReadOnly < bool > | property_can_default () const
| Whether the widget can be the default widget. More...
Glib::PropertyProxy< bool > | property_has_default ()
| Whether the widget is the default widget. More...
Glib::PropertyProxy_ReadOnly < bool > | property_has_default () const
| Whether the widget is the default widget. More...
Glib::PropertyProxy< bool > | property_receives_default ()
| If TRUE, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly < bool > | property_receives_default () const
| If TRUE, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly < bool > | property_composite_child () const
| Whether the widget is part of a composite widget. More...
Glib::PropertyProxy < Glib::RefPtr< Style > > | property_style ()
| The style of the widget, which contains information about how it will look (colors etc). More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Style > > | property_style () const
| The style of the widget, which contains information about how it will look (colors etc). More...
Glib::PropertyProxy < Gdk::EventMask > | property_events ()
| The event mask that decides what kind of GdkEvents this widget gets. More...
Glib::PropertyProxy_ReadOnly < Gdk::EventMask > | property_events () const
| The event mask that decides what kind of GdkEvents this widget gets. More...
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Whether this widget has a tooltip. More...
Glib::PropertyProxy_ReadOnly < bool > | property_has_tooltip () const
| Whether this widget has a tooltip. More...
Glib::PropertyProxy < Glib::ustring > | property_tooltip_markup ()
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_tooltip_markup () const
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy < Glib::ustring > | property_tooltip_text ()
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_tooltip_text () const
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Gdk::Window > > | property_window () const
| The widget's window if it is realized. More...
Glib::PropertyProxy< bool > | property_no_show_all ()
| Whether gtk_widget_show_all() should not affect this widget. More...
Glib::PropertyProxy_ReadOnly < bool > | property_no_show_all () const
| Whether gtk_widget_show_all() should not affect this widget. More...
Glib::PropertyProxy< bool > | property_double_buffered ()
| Whether the widget is double buffered. More...
Glib::PropertyProxy_ReadOnly < bool > | property_double_buffered () const
| Whether the widget is double buffered. More...
Glib::PropertyProxy< Align > | property_halign ()
| How to position in extra horizontal space. More...
Glib::PropertyProxy_ReadOnly < Align > | property_halign () const
| How to position in extra horizontal space. More...
Glib::PropertyProxy< Align > | property_valign ()
| How to position in extra vertical space. More...
Glib::PropertyProxy_ReadOnly < Align > | property_valign () const
| How to position in extra vertical space. More...
Glib::PropertyProxy< int > | property_margin_left ()
| Pixels of extra space on the left side. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_left () const
| Pixels of extra space on the left side. More...
Glib::PropertyProxy< int > | property_margin_right ()
| Pixels of extra space on the right side. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_right () const
| Pixels of extra space on the right side. More...
Glib::PropertyProxy< int > | property_margin_top ()
| Pixels of extra space on the top side. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Pixels of extra space on the top side. More...
Glib::PropertyProxy< int > | property_margin_bottom ()
| Pixels of extra space on the bottom side. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Pixels of extra space on the bottom side. More...
Glib::PropertyProxy< int > | property_margin ()
| Pixels of extra space on all four sides. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin () const
| Pixels of extra space on all four sides. More...
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether widget wants more horizontal space. More...
Glib::PropertyProxy_ReadOnly < bool > | property_hexpand () const
| Whether widget wants more horizontal space. More...
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the hexpand property. More...
Glib::PropertyProxy_ReadOnly < bool > | property_hexpand_set () const
| Whether to use the hexpand property. More...
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether widget wants more vertical space. More...
Glib::PropertyProxy_ReadOnly < bool > | property_vexpand () const
| Whether widget wants more vertical space. More...
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the vexpand property. More...
Glib::PropertyProxy_ReadOnly < bool > | property_vexpand_set () const
| Whether to use the vexpand property. More...
Glib::PropertyProxy< bool > | property_expand ()
| Whether widget wants to expand in both directions. More...
Glib::PropertyProxy_ReadOnly < bool > | property_expand () const
| Whether widget wants to expand in both directions. More...
Glib::PropertyProxy< double > | property_opacity ()
| The opacity of the widget, from 0 to 1. More...
Glib::PropertyProxy_ReadOnly < double > | property_opacity () const
| The opacity of the widget, from 0 to 1. More...
Public Member Functions inherited from Gtk::Object
virtual | ~Object ()
GObject* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GtkObject. More...
Public Member Functions inherited from Gtk::Buildable
virtual | ~Buildable ()
GtkBuildable* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBuildable* | gobj () const
| Provides access to the underlying C GObject. More...
void | set_name (const Glib::ustring& name)
| Sets the name of the buildable object. More...
Glib::ustring | get_name () const
| Gets the name of the buildable object. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Bin
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Container
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Widget* | get_current_modal_grab ()
| Retrieve the widget which is currently grabbing all events. More...
static void | push_composite_child ()
| Makes all newly-created widgets as composite children until the corresponding pop_composite_child() call. More...
static void | pop_composite_child ()
| Cancels the effect of a previous call to push_composite_child(). More...
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets where the direction has not been explicitly set by set_direction(). More...
static TextDirection | get_default_direction ()
| Obtains the current default reading direction. More...
static Widget* | drag_get_source_widget (const Glib::RefPtr< Gdk::DragContext >& context)
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
virtual void | on_child_attached (Widget* child)
| This is a default handler for the signal signal_child_attached(). More...
virtual void | on_child_detached (Widget* child)
| This is a default handler for the signal signal_child_detached(). More...
Protected Member Functions inherited from Gtk::Bin
| Bin ()
| This constructor is protected because only derived classes should be instantiated. More...
Protected Member Functions inherited from Gtk::Container
virtual void | on_add (Widget* widget)
| This is a default handler for the signal signal_add(). More...
virtual void | on_remove (Widget* widget)
| This is a default handler for the signal signal_remove(). More...
virtual void | on_check_resize ()
| This is a default handler for the signal signal_check_resize(). More...
virtual void | on_set_focus_child (Widget* widget)
| This is a default handler for the signal signal_set_focus_child(). More...
| Container ()
virtual GType | child_type_vfunc () const
| Implements child_type(). More...
virtual void | forall_vfunc (gboolean include_internals, GtkCallback callback, gpointer callback_data)
| Invokes a callback on all children of the container. More...
virtual char* | composite_name_vfunc (GtkWidget* child)
| Returns the composite name of a child widget. More...
virtual void | set_child_property_vfunc (GtkWidget* child, guint property_id, const GValue* value, GParamSpec* pspec)
| Sets a child property for this container and its child. More...
virtual void | get_child_property_vfunc (GtkWidget* child, guint property_id, GValue* value, GParamSpec* pspec) const
| Returns a child property for this container and its child. More...
Glib::PropertyProxy< guint > | property_border_width ()
| The width of the empty border outside the containers children. More...
Glib::PropertyProxy_ReadOnly < guint > | property_border_width () const
| The width of the empty border outside the containers children. More...
Glib::PropertyProxy< ResizeMode > | property_resize_mode ()
| Specify how resize events are handled. More...
Glib::PropertyProxy_ReadOnly < ResizeMode > | property_resize_mode () const
| Specify how resize events are handled. More...
Glib::PropertyProxy_WriteOnly < Widget* > | property_child ()
| Can be used to add a new child to the container. More...
Protected Member Functions inherited from Gtk::Widget
virtual void | on_show ()
| This is a default handler for the signal signal_show(). More...
virtual void | on_hide ()
| This is a default handler for the signal signal_hide(). More...
virtual void | on_map ()
| This is a default handler for the signal signal_map(). More...
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap(). More...
virtual void | on_realize ()
| This is a default handler for the signal signal_realize(). More...
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize(). More...
virtual void | on_size_allocate (Allocation& allocation)
| This is a default handler for the signal signal_size_allocate(). More...
virtual void | on_state_changed (Gtk::StateType previous_state)
| This is a default handler for the signal signal_state_changed(). More...
virtual void | on_parent_changed (Widget* previous_parent)
| This is a default handler for the signal signal_parent_changed(). More...
virtual void | on_hierarchy_changed (Widget* previous_toplevel)
| This is a default handler for the signal signal_hierarchy_changed(). More...
virtual void | on_style_updated ()
| This is a default handler for the signal signal_style_updated(). More...
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed(). More...
virtual void | on_grab_notify (bool was_grabbed)
| This is a default handler for the signal signal_grab_notify(). More...
virtual void | on_child_notify (GParamSpec* pspec)
| This is a default handler for the signal signal_child_notify(). More...
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate(). More...
virtual void | on_grab_focus ()
| This is a default handler for the signal signal_grab_focus(). More...
virtual bool | on_focus (DirectionType direction)
| This is a default handler for the signal signal_focus(). More...
virtual bool | on_event (GdkEvent*event)
| This is a default handler for the signal signal_event(). More...
virtual bool | on_button_press_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_press_event(). More...
virtual bool | on_button_release_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_release_event(). More...
virtual bool | on_scroll_event (GdkEventScroll*event)
| This is a default handler for the signal signal_scroll_event(). More...
virtual bool | on_motion_notify_event (GdkEventMotion*event)
| This is a default handler for the signal signal_motion_notify_event(). More...
virtual bool | on_delete_event (GdkEventAny*event)
| This is a default handler for the signal signal_delete_event(). More...
virtual bool | on_draw (const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| This is a default handler for the signal signal_draw(). More...
virtual bool | on_key_press_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_press_event(). More...
virtual bool | on_key_release_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_release_event(). More...
virtual bool | on_enter_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_enter_notify_event(). More...
virtual bool | on_leave_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_leave_notify_event(). More...
virtual bool | on_configure_event (GdkEventConfigure*event)
| This is a default handler for the signal signal_configure_event(). More...
virtual bool | on_focus_in_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_in_event(). More...
virtual bool | on_focus_out_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_out_event(). More...
virtual bool | on_map_event (GdkEventAny*event)
| This is a default handler for the signal signal_map_event(). More...
virtual bool | on_unmap_event (GdkEventAny*event)
| This is a default handler for the signal signal_unmap_event(). More...
virtual bool | on_property_notify_event (GdkEventProperty*event)
| This is a default handler for the signal signal_property_notify_event(). More...
virtual bool | on_selection_clear_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_clear_event(). More...
virtual bool | on_selection_request_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_request_event(). More...
virtual bool | on_selection_notify_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_notify_event(). More...
virtual bool | on_proximity_in_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_in_event(). More...
virtual bool | on_proximity_out_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_out_event(). More...
virtual bool | on_visibility_notify_event (GdkEventVisibility*event)
| This is a default handler for the signal signal_visibility_notify_event(). More...
virtual bool | on_window_state_event (GdkEventWindowState*event)
| This is a default handler for the signal signal_window_state_event(). More...
virtual void | on_selection_get (SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_selection_get(). More...
virtual void | on_selection_received (const SelectionData& selection_data, guint time)
| This is a default handler for the signal signal_selection_received(). More...
virtual void | on_drag_begin (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_begin(). More...
virtual void | on_drag_end (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_end(). More...
virtual void | on_drag_data_get (const Glib::RefPtr< Gdk::DragContext >& context, SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_get(). More...
virtual void | on_drag_data_delete (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_data_delete(). More...
virtual void | on_drag_leave (const Glib::RefPtr< Gdk::DragContext >& context, guint time)
| This is a default handler for the signal signal_drag_leave(). More...
virtual bool | on_drag_motion (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_motion(). More...
virtual bool | on_drag_drop (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_drop(). More...
virtual void | on_drag_data_received (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, const SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_received(). More...
virtual void | on_screen_changed (const Glib::RefPtr< Gdk::Screen >& previous_screen)
| This is a default handler for the signal signal_screen_changed(). More...
virtual void | dispatch_child_properties_changed_vfunc (guint p1, GParamSpec** p2)
virtual void | show_all_vfunc ()
virtual Glib::RefPtr< Atk::Object > | get_accessible_vfunc ()
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | get_preferred_width_vfunc (int& minimum_width, int& natural_width) const
virtual void | get_preferred_height_for_width_vfunc (int width, int& minimum_height, int& natural_height) const
virtual void | get_preferred_height_vfunc (int& minimum_height, int& natural_height) const
virtual void | get_preferred_width_for_height_vfunc (int height, int& minimum_width, int& natural_width) const
| Widget ()
void | realize ()
| Creates the GDK (windowing system) resources associated with a widget. More...
void | unrealize ()
| This function is only useful in widget implementations. More...
void | draw (const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| Draws widget to cr. More...
void | set_mapped (bool mapped=true)
| Marks the widget as being realized. More...
void | set_realized (bool realized=true)
| Marks the widget as being realized. More...
void | set_has_window (bool has_window=true)
| Specifies whether widget has a Gdk::Window of its own. More...
void | set_window (const Glib::RefPtr< Gdk::Window >& window)
| Sets a widget's window. More...
void | transform_cairo_context_to_window (const ::Cairo::RefPtr< ::Cairo::Context >& cr, const Glib::RefPtr< const Gdk::Window >& window)
| Transforms the given cairo context cr from widget-relative coordinates to window-relative coordinates. More...
Requisition | get_requisition () const
| Retrieves the widget's requisition. More...
void | get_style_property_value (const Glib::ustring& the_property_name, Glib::ValueBase& value) const
| Gets the value of a style property of widget. More...
void | realize_if_needed ()
void | insert_action_group (const Glib::ustring& name, const Glib::RefPtr< Gio::ActionGroup >&group)
| Inserts group into widget. More...
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Gtk::HandleBox* | wrap (GtkHandleBox* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Bin
Gtk::Bin* | wrap (GtkBin* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Container
Gtk::Container* | wrap (GtkContainer* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Widget
Gtk::Widget* | wrap (GtkWidget* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gtk::Container
typedef sigc::slot< void, Widget& > | ForeachSlot
| For instance, void on_foreach(Gtk::Widget* widget);. More...
Static Protected Member Functions inherited from Gtk::Widget
static bool | should_draw_window (const ::Cairo::RefPtr< const ::Cairo::Context >& cr, const Glib::RefPtr< const Gdk::Window >& window)
| This function is supposed to be called in Gtk::Widget::signal_draw() implementations for widgets that support multiple windows. More...

## Detailed Description

A widget for detachable window portions.

The Gtk::HandleBox widget allows a portion of a window to be "torn off". It displays its child and a handle that the user can drag to tear off a separate window (the float window) containing the child widget. A thin ghost is drawn in the original location of the handlebox. By dragging the separate window back to its original location, it can be reattached. When reattaching, the ghost and float window must be aligned along one of the edges, the snap edge. This can be specified by the application programmer explicitely, or GTK+ will pick a reasonable default based on the handle position. To make detaching and reattaching the handlebox as minimally confusing as possible to the user, it is important to set the snap edge so that the snap edge does not move when the handlebox is deattached. For instance, if the handlebox is packed at the bottom of a VBox, then when the handlebox is detached, the bottom edge of the handlebox's allocation will remain fixed as the height of the handlebox shrinks, so the snap edge should be set to GTK_POS_BOTTOM.

Deprecated:
  This is very specialized, lacks features to make it useful and most importantly does not fit well into modern application design. There is no replacement.

## Constructor & Destructor Documentation

virtual Gtk::HandleBox::~HandleBox | ( |  | ) |
| virtual

Gtk::HandleBox::HandleBox | ( |  | ) |

## Member Function Documentation

PositionType Gtk::HandleBox::get_handle_position | ( |  | ) | const

Gets the handle position of the handle box.

See set_handle_position().

Deprecated: 3.4: Gtk::HandleBox has been deprecated.

Returns
  The current handle position.

ShadowType Gtk::HandleBox::get_shadow_type | ( |  | ) | const

Gets the type of shadow drawn around the handle box.

See set_shadow_type().

Deprecated: 3.4: Gtk::HandleBox has been deprecated.

Returns
  The type of shadow currently drawn around the handle box.

PositionType Gtk::HandleBox::get_snap_edge | ( |  | ) | const

Gets the edge used for determining reattachment of the handle box.

See set_snap_edge().

Deprecated: 3.4: Gtk::HandleBox has been deprecated.

Returns
  The edge used for determining reattachment, or (GtkPositionType)-1 if this is determined (as per default) from the handle position.

static GType Gtk::HandleBox::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GtkHandleBox* Gtk::HandleBox::gobj | ( |  | ) |
| inline

Provides access to the underlying C GtkObject.

const GtkHandleBox* Gtk::HandleBox::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GtkObject.

bool Gtk::HandleBox::is_child_detached | ( |  | ) | const

Whether the handlebox's child is currently detached.

Since gtkmm 2.14:

Deprecated: 3.4: Gtk::HandleBox has been deprecated.

Returns
  `true` if the child is currently detached, otherwise `false`.

virtual void Gtk::HandleBox::on_child_attached | ( | Widget* | child | ) |
| protectedvirtual

This is a default handler for the signal signal_child_attached().

virtual void Gtk::HandleBox::on_child_detached | ( | Widget* | child | ) |
| protectedvirtual

This is a default handler for the signal signal_child_detached().

Glib::PropertyProxy_ReadOnly< bool > Gtk::HandleBox::property_child_detached | ( |  | ) | const

A boolean value indicating whether the handlebox's child is attached or detached.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< PositionType > Gtk::HandleBox::property_handle_position | ( |  | ) |

Position of the handle relative to the child widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< PositionType > Gtk::HandleBox::property_handle_position | ( |  | ) | const

Position of the handle relative to the child widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< ShadowType > Gtk::HandleBox::property_shadow_type | ( |  | ) |

Appearance of the shadow that surrounds the container.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< ShadowType > Gtk::HandleBox::property_shadow_type | ( |  | ) | const

Appearance of the shadow that surrounds the container.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< PositionType > Gtk::HandleBox::property_snap_edge | ( |  | ) |

Side of the handlebox that's lined up with the docking point to dock the handlebox.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< PositionType > Gtk::HandleBox::property_snap_edge | ( |  | ) | const

Side of the handlebox that's lined up with the docking point to dock the handlebox.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::HandleBox::property_snap_edge_set | ( |  | ) |

Whether to use the value from the snap_edge property or a value derived from handle_position.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::HandleBox::property_snap_edge_set | ( |  | ) | const

Whether to use the value from the snap_edge property or a value derived from handle_position.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gtk::HandleBox::set_handle_position | ( | PositionType | position | ) |

Sets the side of the handlebox where the handle is drawn.

Deprecated: 3.4: Gtk::HandleBox has been deprecated.

Parameters

  position | The side of the handlebox where the handle should be drawn.

void Gtk::HandleBox::set_shadow_type | ( | ShadowType | type | ) |

Sets the type of shadow to be drawn around the border of the handle box.

Deprecated: 3.4: Gtk::HandleBox has been deprecated.

Parameters

  type | The shadow type.

void Gtk::HandleBox::set_snap_edge | ( | PositionType | edge | ) |

Sets the snap edge of a handlebox.

The snap edge is the edge of the detached child that must be aligned with the corresponding edge of the "ghost" left behind when the child was detached to reattach the torn-off window. Usually, the snap edge should be chosen so that it stays in the same place on the screen when the handlebox is torn off.

If the snap edge is not set, then an appropriate value will be guessed from the handle position. If the handle position is Gtk::POS_RIGHT or Gtk::POS_LEFT, then the snap edge will be Gtk::POS_TOP, otherwise it will be Gtk::POS_LEFT.

Deprecated: 3.4: Gtk::HandleBox has been deprecated.

Parameters

  edge | The snap edge, or -1 to unset the value; in which case GTK+ will try to guess an appropriate value in the future.

Glib::SignalProxy1< void,Widget* > Gtk::HandleBox::signal_child_attached | ( |  | ) |

Slot Prototype:
  `void on_my_child_attached(Widget* child)`

This signal is emitted when the contents of the handlebox are reattached to the main window.

Deprecated: 3.4: Gtk::HandleBox has been deprecated.

Parameters

  widget | The child widget of the handlebox. (this argument provides no extra information and is here only for backwards-compatibility).

Glib::SignalProxy1< void,Widget* > Gtk::HandleBox::signal_child_detached | ( |  | ) |

Slot Prototype:
  `void on_my_child_detached(Widget* child)`

This signal is emitted when the contents of the handlebox are detached from the main window.

Deprecated: 3.4: Gtk::HandleBox has been deprecated.

Parameters

  widget | The child widget of the handlebox. (this argument provides no extra information and is here only for backwards-compatibility).

## Friends And Related Function Documentation

Gtk::HandleBox* wrap | ( | GtkHandleBox * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/handlebox.h